//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "AddrsDlg.h"
#include "FileMan.h"
#include "Global.h"

const AnsiString General = "General";
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAddressDlg *AddressDlg;
//---------------------------------------------------------------------------
bool __fastcall GetMailRecipients(TStrings *Addresses, int Mode)
{
   int i;
   AnsiString s;
   Addresses->Clear();
   AddressDlg = new TAddressDlg(Application->MainForm);
   AddressDlg->SetMode(Mode);
   AddressDlg->ShowModal();
   if (AddressDlg->ModalResult==mrOk)
   {
      for (i=0; i<AddressDlg->AddrsList->Items->Count; i++)
         if (AddressDlg->AddrsList->Selected[i])
            Addresses->Add(AddressDlg->AddrsList->Items->Strings[i]);
      for (i=0; i<Addresses->Count; i++)
      {
         s = Addresses->Strings[i];
         if (i>0) s = " " + s;
         if (i<Addresses->Count-1) s += ",";
         Addresses->Strings[i] = s;
      }
      if (Addresses->Count)
      {
         s = Addresses->Strings[0];
         if (AddressDlg->BccBtn->Checked) Addresses->Strings[0] = "Bcc: "+s; else
         if (AddressDlg->CcBtn->Checked) Addresses->Strings[0] = "Cc: "+s; else
         if (AddressDlg->ToBtn->Checked) Addresses->Strings[0] = "To: "+s;
      }
   }
   delete AddressDlg;
   return Addresses->Count>0;
}
//---------------------------------------------------------------------------
__fastcall TAddressDlg::TAddressDlg(TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // initialize
   GetAppData(AddrsList->Items,UserAddresses+PS+General);
   AddrsEditor->Align = alClient;
   orglistwidth = Panel3->Width;
   mode = modeNone;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::SetMode(int newMode)
{
   if (newMode==modeAddress)
   {
      bool locked=LockWindowUpdate(Handle);
      if (mode==modeEdit)
      {
         OkBtn->Caption = "Ok";
         AddrsList->Sorted = true;
         AddrsList->Items->Text = AddrsEditor->Lines->Text;
         PutAppData(UserAddresses+PS+General,AddrsList->Items);
         AddrsList->Sorted = false;
      }
      AddrsList->Visible = true;
      Panel3->Align = alLeft;
      Panel3->Width = orglistwidth;
      Label1->Visible = true;
      for (int i=0; i<AddrsList->Items->Count; i++)
         AddrsList->Selected[i] = false;
      ActiveControl = AddrsList;
      if (locked) LockWindowUpdate(0);
      //MyBeep(MB_OK);
   }
   else
   if (newMode==modeEdit)
   {
      bool locked=LockWindowUpdate(Handle);
      AddrsEditor->Lines->Text = AddrsList->Items->Text;
      AddrsEditor->Modified = false;
      AddrsList->Visible = false;
      AddrsEditor->SelStart = 0;
      Panel3->Align = alClient;
      Label1->Visible = false;
      ActiveControl = AddrsEditor;
      OkBtn->Caption = "Done";
      if (locked) LockWindowUpdate(0);
      //MyBeep(MB_OK);
   }
   else
   if (newMode==modeNoAddress)
   {
      bool locked=LockWindowUpdate(Handle);
      AddrsEditor->Lines->Text = AddrsList->Items->Text;
      AddrsEditor->Modified = false;
      AddrsList->Visible = false;
      AddrsEditor->SelStart = 0;
      Panel3->Align = alClient;
      Label1->Visible = false;
      ActiveControl = AddrsEditor;
      OkBtn->Caption = "Ok";
      if (locked) LockWindowUpdate(0);
   }
   mode = newMode;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::EditBtnClick(TObject *Sender)
{
   SetMode(modeEdit);
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::OkBtnClick(TObject *Sender)
{
   if (OkBtn->Caption=="Done")
   {
      SetMode(modeAddress);
      return;
   }
   if (mode==modeNoAddress && AddrsEditor->Modified)
      PutAppData(UserAddresses+PS+General,AddrsEditor->Lines);
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::AddrsListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::CancelBtnClick(TObject *Sender)
{
   if (OkBtn->Caption=="Done" || mode==modeNoAddress)
   {
      if (AddrsEditor->Modified && MsgBoxHwnd(Handle,
         "Your Address Book is modified!\n\nAre you sure you want to cancel?",
         "Address Book",MB_YESNO)==IDNO)
              return;

      if (mode != modeNoAddress)
      {
         SetMode(modeAddress);
         return;
      }
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------