//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FileWin.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma link "explbtn"
#pragma resource "*.dfm"
TTextFileWin *TextFileWin;
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   if (FileExists(filename))
   {
      TStringList *txt = new TStringList();
      txt->LoadFromFile(filename);
      SetText("...\\"+ExtractFileName(Filename),txt);
      delete txt;
   }
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TStrings *Txt, AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   SetText("...\\"+ExtractFileName(Filename),Txt);
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::SaveAs()
{// not needed but placed for safety
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::SetText(AnsiString &Name, TStrings *Text)
{
//   IndexStr = Name;
//   DataKey = UserNotes+PS+Name;
   Caption = Name;
   Editor->OnSelectionChange = NULL;
   Editor->Lines->Text = Text->Text;
   Editor->Modified = false;
   Editor->SelStart = 0;
   Editor->OnSelectionChange = EditorSelectionChange;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::Save()
{
   Editor->Lines->SaveToFile(filename);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,
            ExtractFileName(filename).UpperCase()+" has been modified. Changes will be lost!\n\nSave it now?",
               "Save File",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
