#define _WINSOCKAPI_      // Prevent winsock.h from being included
#include <vcl\vcl.h>
#pragma hdrstop

#include "HttpDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "UrlsDlg.h"
#include "Mixmaster.h"
//---------------------------------------------------------------------------
#pragma link "HttpProt"
#pragma link "explbtn"
#pragma resource "*.dfm"
THttpForm *HttpForm;
#define CHECKING "testing"
#define hsleep 100
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *owner, bool attended)
{
   HttpForm = new THttpForm(owner);
   CenterDialog(HttpForm,owner);
   bool ok = HttpForm->Execute(attended);
   delete HttpForm;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall THttpForm::THttpForm(TComponent* Owner)
    : TForm(Owner)
{
   DocMemo->Font->Name = GetAppIni("FontName","Courier New");
   DocMemo->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   CenterDialog(this);
   PageControl1->ActivePage = TabSheet1;
   Label1->Caption = "";

   LoadHttpInfo();
   HttpCli1->RcvdStream = NULL;
   Tabs = TabSet->Tabs;
   Cancelled = false;
   Attended = false;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   int goodtabs=0;
   if (Tabs->Count>1)
      for (int i=0; i<Tabs->Count; i++)
         if (Tabs->Strings[i]!="Error" || Tabs->Strings[i]!=CHECKING)
            goodtabs++;

   if (ModalResult==mrOk && goodtabs>0) SaveStatistics();
   else
   if (Attended && ModalResult==mrCancel && goodtabs>0)// && GetBtn->Caption=="Done")
   {
      int reply = MsgBoxHwnd(Handle,"Your new remailer docs are not saved!\n\nSave them now?",
            "Remailer Documents",MB_YESNOCANCEL);
      switch (reply)
      {
         case ID_CANCEL: CanClose=false; break;
         case ID_YES: SaveStatistics(); break;
      }
      if (!CanClose) return;
   }
   delete HttpCli1->RcvdStream;

   StoreHttpInfo();
   for (int i=0; i<TabSet->Tabs->Count; i++)
   {
      TStringList *TxtList = (TStringList*)TabSet->Tabs->Objects[i];
      delete TxtList;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;
   GetBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormShow(TObject *Sender)
{
   GetAppURLs();
   ActiveControl = Panel2;
   if (!Attended)
   {
      RichEdit1->Visible = false;
      //Label7->Visible = false;
      PageControl1->ActivePage = TabSheet3;
      Application->ProcessMessages();
      Timer2->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SaveStatistics()
{
   AnsiString TxtFile;
   TStringList *TxtList;
   int idx = TabSet->TabIndex;
   if (idx>=0) ((TStringList*)TabSet->Tabs->Objects[idx])->Text = DocMemo->Lines->Text;
   for (int i=0; i<TabSet->Tabs->Count; i++)
   {
      TxtFile = TabSet->Tabs->Strings[i];
      if (TxtFile=="Error" || TxtFile==CHECKING) continue;
      TxtList = (TStringList*)TabSet->Tabs->Objects[i];
      TxtList->SaveToFile(MixDir()+TxtFile);
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetBtnClick(TObject *Sender)
{
   if (Cancelled)
   {
      ResetCheckboxes();
      return;
   }

   if (GetBtn->Enabled && GetBtn->Caption=="Get Docs")
      UrlsBtn->Enabled = false;
   OkBtn->Enabled = false;
   GetBtn->Enabled = false;
   for (int i=0; i<Tabs->Count; i++)
   {
      delete (TStringList*)Tabs->Objects[i];
      Tabs->Objects[i] = NULL;
      Tabs->Delete(i);
   }
   if (!Timer1->Enabled) Timer1->Enabled = true;

   if (MListBox->Enabled && MListBox->Checked)
      GetStatistics(MListURL,MListBox,MListTxt);
   else
   if (MRingBox->Enabled && MRingBox->Checked)
      GetStatistics(MRingURL,MRingBox,MRingTxt);
   else
   if (MTyp2Box->Enabled && MTyp2Box->Checked)
      GetStatistics(MTyp2URL,MTyp2Box,MTyp2Txt);
   else
   if (CListBox->Enabled && CListBox->Checked)
      GetStatistics(CListURL,CListBox,CListTxt);
   else
   if (CRingBox->Enabled && CRingBox->Checked)
      GetStatistics(CRingURL,CRingBox,CRingTxt);
   else
   {
      ResetCheckboxes();
      ProgressBar1->Visible = false;

      TStringList *tmp = new TStringList();
      TabSet->Tabs->AddObject(CHECKING,tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      PageControl1->ActivePage = TabSheet3;
      if (ErrorMixmasterDocs(DocMemo->Lines))
         Attended = true;

      ActiveControl = DocMemo;
      UrlsBtn->Enabled = true;
      OkBtn->Enabled = true;
      Label1->Caption = "";
      Cancelled = false;

      if (Attended) MyBeep(MB_OK);
      else
      {
         ProgressBar1->Visible = false;
         CancelBtn->Enabled = false;
         OkBtn->Enabled = false;
         SaveStatistics();        // could have gotten valid page before cancel
         Sleep(1000);
         ModalResult = !Cancelled || (Cancelled && TabSet->Tabs->Count>1) ?
            mrOk : mrCancel;
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GetDoc(TStrings* Doc, AnsiString &Docname)
{
   int pos;
   Doc->Clear();
   if ((pos=Tabs->IndexOf(Docname))>=0)
   {
      Doc->Text = dynamic_cast<TStrings*>(Tabs->Objects[pos])->Text;
      if (Doc && Doc->Count) return true;
   }
   else
   if (FileExists(MixDir()+Docname))
   {
      Doc->LoadFromFile(MixDir()+Docname);
      if (Doc->Count) return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GotDoc(AnsiString &Docname)
{
   return Tabs->IndexOf(Docname)>=0 ? true:false;
}
//---------------------------------------------------------------------------
void __fastcall LogAdd(AnsiString &msg, TStrings *Log)
{
   Log->Add(msg); Sleep(hsleep);
}
//---------------------------------------------------------------------------
bool __fastcall StatsLineOk(AnsiString &line)
{
   return (line.Length()==44 && line[34]==':' && line[41]=='.' && line[44]=='%');
}
//---------------------------------------------------------------------------
bool __fastcall MKeyDescriptionOk(AnsiString &descrip)
{
   int fld=0;
   bool ok=true;
   AnsiString data;
   while (ok && !(data=GetParam(fld,descrip," ")).IsEmpty())
   {
      if (fld==1 && data.Pos("@")<1) ok = false;
      if (fld==3 && data.Pos(".")<1) ok = false;
      fld++;
   }
   if (fld!=4 && fld!=5) ok = false;
   return ok;
}
//---------------------------------------------------------------------------
int __fastcall THttpForm::MlistTxtErr(TStrings *Doc, TStrings *ErrLog)
{
   int p,errs=0;
   AnsiString line;
   //LogAdd(" Checking mlist.txt...",ErrLog);
   bool head1=false,head2=false,head3=false,instats=false;
   for (int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i].Trim();
      if (!instats && line.LowerCase().Pos("last update: ")==1) head1 = true;
      if (!instats && line.LowerCase().Pos("mixmaster ")==1) head2 = true;
      if (!instats && line.LowerCase().Pos("-----")==1) head3 = true;
      if (head1 && head2 && head3 && !instats && !line.IsEmpty())
      {
         instats = true; p = i;
         continue;
      }
      if (instats && !line.IsEmpty() && !StatsLineOk(line))
      {
         LogAdd(
            " Mlist.txt error: Bad stats at line "+AnsiString(i-p)+
            " \r\n  -> "+line,
            ErrLog
         );
         errs++;
      }
      if (instats && line.IsEmpty()) break;
   }
   if (!head1 || !head2 || !head3)
   {
      LogAdd(
         " Mlist.txt error: document appears corrupt.",
         ErrLog
      );
      errs++;
   }
   if (!errs) LogAdd(" mlist.txt ok",ErrLog);

   return errs;
}
//---------------------------------------------------------------------------
int __fastcall THttpForm::PubringMixErr(TStrings *Doc, TStrings *ErrLog)
{
   //LogAdd(" Checking pubring.mix...",ErrLog);
   AnsiString line;
   bool inkey=false;
   int b=0,e=0,errs=0;
   for (int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i].Trim();
      if (line=="-----Begin Mix Key-----") { inkey = true; b++; }
      if (!inkey && !line.IsEmpty() && !MKeyDescriptionOk(line))
      {
         LogAdd(
            " Pubring.mix error: Bad key description at line "+AnsiString(i+1)+
            " \r\n  -> "+line,
            ErrLog
         );
         errs++;
      }
      if (line=="-----End Mix Key-----") { inkey = false; e++; }
   }
   if (!b)
   {
      LogAdd(" Pubring.mix error: No 'Begin Key' markers.",ErrLog);
      errs++;
   }
   if (!e)
   {
      LogAdd(" Pubring.mix error: No 'End Key' markers.",ErrLog);
      errs++;
   }
   if (b && e && b!=e)
   {
      LogAdd(
         " Pubring.mix error: AnsiString(b)+'Begin Key' markers, "+AnsiString(e)+
         " 'End Key' markers",
         ErrLog
      );
      errs++;
   }
   if (!errs) LogAdd(" pubring.mix ok",ErrLog);

   return errs;
}
//---------------------------------------------------------------------------
int __fastcall THttpForm::Type2ListErr(TStrings *Doc, TStrings *ErrLog)
{
   int errs=0;
   //LogAdd(" Checking type2.list...",ErrLog);
   if (!Doc->Count)
         LogAdd(" No type2.list present, but this document is not require.",ErrLog);
   else
   {
      for (int i=0; i<Doc->Count; i++)
      {
         AnsiString line = Doc->Strings[i].Trim();
         if (!MKeyDescriptionOk(line))
         {
             LogAdd(
                " Type2.list error: Bad Key description at line "+AnsiString(i+1)+
                " \r\n  -> "+line,
                ErrLog
             );
             errs++;
         }
      }
   }

   //if (errs >1) LogAdd(" type2.list errors found!",ErrLog); else
   //if (errs==1) LogAdd(" type2.list error found!",ErrLog); else
   if (!errs) LogAdd(" type2.list ok",ErrLog);

   return errs;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::ErrorMixmasterDocs(TStrings *ErrLog)
{
   bool ok1,ok2,ok3;
   LogAdd("Checking Mix documents for errors",ErrLog);

   TStringList *mlist = new TStringList(); GetDoc(mlist,MListTxt);
   TStringList *pring = new TStringList(); GetDoc(pring,MRingTxt);
   TStringList *type2 = new TStringList(); GetDoc(type2,MTyp2Txt);
   if (!GotDoc(MListTxt)) Tabs->AddObject(MListTxt,mlist);
   if (!GotDoc(MRingTxt)) Tabs->AddObject(MRingTxt,pring);
   if (!GotDoc(MTyp2Txt)) Tabs->AddObject(MTyp2Txt,type2);

   ok1 = !MlistTxtErr(mlist,ErrLog);
   ok2 = !PubringMixErr(pring,ErrLog);
   ok3 = !Type2ListErr(type2,ErrLog);

   if (!ok1 || !ok2 || !ok3) LogAdd("Mixmaster document error(s)",ErrLog);
   else LogAdd("Mixmaster documents ok!",ErrLog);

   delete type2;
   delete pring;
   delete mlist;
   return ok1 && ok2 && ok3;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::ErrorCyberpunkDocs(TStrings *ErrLog)
{
   bool hasErr=false;
   return hasErr;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::LoadHttpInfo()
{
   TStringList *http = new TStringList();
   if (AppDataExists(HttpInfo,http))
   {
      //sm(http->Text);
      MListBox->Checked = http->Values["MListChkd"] == "1";
      MRingBox->Checked = http->Values["MRingChkd"] == "1";
      MTyp2Box->Checked = http->Values["MTyp2Chkd"] == "1";
      CListBox->Checked = http->Values["CListChkd"] == "1";
      CRingBox->Checked = http->Values["CRingChkd"] == "1";
      ProxyHostEdit->Text = http->Values["ProxyHost"];
      ProxyPortEdit->Text = http->Values["ProxyPort"];
      ProxyPswdEdit->Text = http->Values["ProxyPswd"];
      ProxyUserEdit->Text = http->Values["ProxyUser"];
   }
   Http = http->Text; // keep for later compare to see if modified
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::StoreHttpInfo()
{
   TStringList *http = new TStringList();
   http->Add("MListChkd="+AnsiString(MListBox->Checked?"1":"0"));
   http->Add("MRingChkd="+AnsiString(MRingBox->Checked?"1":"0"));
   http->Add("MTyp2Chkd="+AnsiString(MTyp2Box->Checked?"1":"0"));
   http->Add("CListChkd="+AnsiString(CListBox->Checked?"1":"0"));
   http->Add("CRingChkd="+AnsiString(CRingBox->Checked?"1":"0"));
   http->Add("ProxyHost="+ProxyHostEdit->Text);
   http->Add("ProxyPort="+ProxyPortEdit->Text);
   http->Add("ProxyPswd="+ProxyPswdEdit->Text);
   http->Add("ProxyUser="+ProxyUserEdit->Text);
   if (Http!=http->Text) // test for modified
      PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::Execute(bool attended)
{
   Attended = attended; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
//void __fastcall THttpForm::SetButtonState(bool enabled)
//{
//   GetBtn->Enabled = enabled;
//}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GetStatistics(AnsiString &forURL, TCheckBox *Box,
   AnsiString &Doc)
{
   CurDoc = Doc;
   CurBox = Box;
   Cap = forURL;//+"...";
   Label1->Caption = Cap;
   //CancelBtn->Caption = "Cancel";
   HttpCli1->URL = forURL;
   HttpCli1->Proxy = ProxyHostEdit->Text;
   HttpCli1->ProxyPort = ProxyPortEdit->Text;
   HttpCli1->ProxyUsername = ProxyUserEdit->Text;
   HttpCli1->ProxyPassword = ProxyPswdEdit->Text;
   HttpCli1->ModifiedSince = 0;
   ProgressBar1->Position = 0;
   ProgressBar1->Visible = true;
   BytesReceived = 0;

   try {
       HttpCli1->HeadASync();
   } __except (TRUE) {
       GetBtn->Enabled = true; //SetButtonState(true);
       DocMemo->Clear();
       DocMemo->Lines->Add("Head Failed !");
       DocMemo->Lines->Add("Status = " + IntToStr(HttpCli1->StatusCode));
       DocMemo->Lines->Add("Reason = " + HttpCli1->ReasonPhrase);
       PageControl1->ActivePage = TabSheet3;
       ProgressBar1->Visible = false;
       return false;
   }
   return !Cancelled;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ResetCheckboxes()
{
   Timer1->Enabled = false;
   if (MListBox->Checked) MListBox->Enabled = true;
   if (MRingBox->Checked) MRingBox->Enabled = true;
   if (MTyp2Box->Checked) MTyp2Box->Enabled = true;
   if (CListBox->Checked) CListBox->Enabled = true;
   if (CRingBox->Checked) CRingBox->Enabled = true;
   if (Attended) GetBtn->Enabled = true; //SetButtonState(true);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocBegin(TObject *Sender)
{
   BytesReceived = 0;
   ProgressBar1->Position = 0;
   if (HttpCli1->RcvdStream) delete HttpCli1->RcvdStream;
   HttpCli1->RcvdStream = new TMemoryStream();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len)
{
   if (BytesTotal>0)
   {
      BytesReceived += Len;
      ProgressBar1->Position = (BytesReceived/BytesTotal)*100;
      Sleep(200);
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocEnd(TObject *Sender)
{
   ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1RequestDone(TObject *Sender,
	THttpRequest RqType, WORD Error)
{
   TStringList *tmp;
   AnsiString s,TxtFile;
   if (Error)
   {
      //GetBtn->Caption = "Done";
      PageControl1->ActivePage = TabSheet3;
      TStringList *tmp = new TStringList();
      tmp->Add("HTTP Error = "+AnsiString(Error));
      tmp->Add("HTTP Reason = "+HttpCli1->ReasonPhrase);
      TabSet->Tabs->AddObject("Error",tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      DocMemo->Lines->Text = tmp->Text;
//    while (TabSet->Tabs->Count)
//    {
//       DocMemo->Clear();
//       TStringList *tmp = (TStringList*)TabSet->Tabs->Objects[0];
//       TabSet->Tabs->Delete(0);
//       delete tmp;
//    }
      UrlsBtn->Enabled = true;
      return;
   }
   switch (RqType)
   {
      case httpHEAD:
      {
         for (int i=0; i<HttpCli1->RcvdHeader->Count; i++)
         {
            s = HttpCli1->RcvdHeader->Strings[i];
            if (s.Pos("Content-Length: ")==1)
               BytesTotal = s.SubString(17,16).ToIntDef(0);
         }
         HttpCli1->GetASync();
         break;
      }
      case httpGET:
      {
         tmp = new TStringList();
         HttpCli1->RcvdStream->Seek(0,soFromBeginning);
         tmp->LoadFromStream(HttpCli1->RcvdStream);
         int idx = TabSet->Tabs->IndexOf(CurDoc);
         if (idx>=0)
         {  // this is already downloaded & needs to be replaced
            TStringList *old = (TStringList*)TabSet->Tabs->Objects[idx];
            TabSet->Tabs->Objects[idx] = (TObject*)tmp;
            delete old;
         }
         else
         {  // new doc
            TabSet->Tabs->AddObject(CurDoc,tmp);
            idx = TabSet->Tabs->Count-1;
         }
         TabSet->TabIndex = idx;
         // handle html
         AnsiString doc = tmp->Text.UpperCase();
         if (doc.Pos("<HTML>") && doc.Pos("<PRE>") && doc.Pos("</PRE>"))
         {
            while (tmp->Count && tmp->Strings[0].UpperCase().Trim()!="<PRE>")
               tmp->Delete(0); if (tmp->Count) tmp->Delete(0);
            while (tmp->Count && tmp->Strings[tmp->Count-1].UpperCase().Trim()!="</PRE>")
               tmp->Delete(tmp->Count-1);
            if (tmp->Count) tmp->Delete(tmp->Count-1);
         }
         // end handle html
         DocMemo->Lines->Text = tmp->Text;
         CurBox->Enabled = false;
         Label1->Caption = "";
         Application->ProcessMessages();
         Sleep(hsleep);
         GetBtn->Click();
         delete HttpCli1->RcvdStream;
         HttpCli1->RcvdStream = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall THttpForm::GetDefaultURL(AnsiString &path)
{
   AnsiString URL;
   TStringList *urls = new TStringList(); GetAppData(urls,path);
   if (urls->Count) URL = urls->Strings[0];
   delete urls;
   return URL;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetAppURLs()
{
   if ((MListURL = GetDefaultURL(StatsURLs+PS+MListTxt)) == "") {
      MListBox->Checked=false; MListBox->Enabled=false;
   } else MListBox->Enabled=true;

   if ((MRingURL = GetDefaultURL(StatsURLs+PS+MRingTxt)) == "") {
      MRingBox->Checked=false; MRingBox->Enabled=false;
   } else MRingBox->Enabled=true;

   if ((MTyp2URL = GetDefaultURL(StatsURLs+PS+MTyp2Txt)) == "") {
      MTyp2Box->Checked=false; MTyp2Box->Enabled=false;
   } else MTyp2Box->Enabled=true;

   if ((CListURL = GetDefaultURL(StatsURLs+PS+CListTxt)) == "") {
      CListBox->Checked=false; CListBox->Enabled=false;
   } else CListBox->Enabled=true;

   if ((CRingURL = GetDefaultURL(StatsURLs+PS+CRingTxt)) == "") {
      CRingBox->Checked=false; CRingBox->Enabled=false;
   } else CRingBox->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CancelBtnClick(TObject *Sender)
{
   Timer1->Enabled = false; Label1->Caption = "";
   OkBtn->Enabled = true;
   if (!GetBtn->Enabled)
   {
      //CancelBtn->Caption = "Close";
      GetBtn->Enabled = true;
      HttpCli1->Abort();
//    Cancelled = true;
      if (Attended)
         return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer1Timer(TObject *Sender)
{
   if (Label1->Caption=="") Label1->Caption = Cap; else Label1->Caption = "";
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ProxyPswdBoxClick(TObject *Sender)
{
   if (!ProxyPswdBox->Checked)
      ProxyPswdEdit->PasswordChar = '\0';
   else
      ProxyPswdEdit->PasswordChar = '*';
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   if (PageControl1->ActivePage==TabSheet3)
      ActiveControl = DocMemo;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::UrlsBtnClick(TObject *Sender)
{
   ManageURLs(this);
   GetAppURLs();
}
//---------------------------------------------------------------------------
#define TABSTRINGS(i) ((TStringList*)TabSet->Tabs->Objects[i])
void __fastcall THttpForm::TabSetChange(TObject *Sender, int NewTab,
   bool &AllowChange)
{
   bool locked=LockWindowUpdate(Handle);
   int idx = TabSet->TabIndex;
   if (idx>=0) TABSTRINGS(idx)->Text = DocMemo->Lines->Text;
   DocMemo->Lines->Text = TABSTRINGS(NewTab)->Text;
   DocMemo->SelStart = 0;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormResize(TObject *Sender)
{
   CancelBtn->Left = Width - 95;
   OkBtn->Left = Width - 179;
   GetBtn->Left = Width - 265;
   ProgressBar1->Width = Width - 297;
   Label1->Top = Height - 74;
   Label1->Width = Width - 42;//ProgressBar1->Left+(ProgressBar1->Width/2)-(Label1->Width/2);
}
//---------------------------------------------------------------------------
