//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PreferDlg.h"
#include "global.h"
#include "fileman.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPreferForm *PreferForm;
//---------------------------------------------------------------------------
bool __fastcall GetPreferences()
{
   bool ok=false;
   TColor mfcolor = AppMainForm->Color;
   PreferForm = new TPreferForm(AppMainForm);
   CenterDialog(PreferForm,AppMainForm);
   PreferForm->ShowModal();
   if (PreferForm->ModalResult==mrOk) ok=true;
   else
   {
      if (AppMainForm->Color != mfcolor)
      {
          AppMainForm->Color = mfcolor;
        ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TPreferForm::TPreferForm(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString txt;
   ini = new TStringList();
   GetAppData(ini,AppIniValues);
   // general
   txt = ini->Values[QuoteMarks];
   if (txt.IsEmpty()) txt = "> "; txt = "\""+txt+"\"";
   QuoteMarkEdit->Text = txt;
   ColorBox->Color = AppMainForm->Color;
   GetAppData(ColorDialog1->CustomColors,"CustomColors");
   StatsMinutes->Text = ini->Values[StatsMinUpdates];
   // editor
   EdWrapWinBtn->Checked = ini->Values[WordWrap].ToIntDef(1);
   EdWrapNotBtn->Checked = !EdWrapWinBtn->Checked;
   EdWrapShowBox->Checked = ini->Values[WordWrapShowBox].ToIntDef(0);
   // sending mail
   bool checked = ini->Values[SendWrapChars].ToIntDef(0);
   SendWrapCharEdit->Color = checked ? clWindow:clBtnFace;
   SendWrapCharBtn->Checked = checked;
   if (!SendWrapCharBtn->Checked) SendWrapCharEdit->Enabled = false;
   txt = ini->Values[SendWrapCharsCount];
   SendWrapCharEdit->Text = txt.IsEmpty()?AnsiString("65"):txt;
   SendWrapWinBtn->Checked = ini->Values[SendWrapWin].ToIntDef(1);
   SendWrapNotBtn->Checked = ini->Values[SendWrapNot].ToIntDef(0);
   DontWrapQuotes->Checked = ini->Values[DontWrapQuoted].ToIntDef(0);
   // init
   PageControl1->ActivePage = TabSheet3;
}
/*
__fastcall TPreferForm::TPreferForm(TComponent* Owner)
  : TForm(Owner)
{
   // general
   AnsiString qm = GetAppIni(QuoteMarks,"");
   if (qm.IsEmpty()) qm = "> ";
   qm = "\""+qm+"\"";
   QuoteMarkEdit->Text = qm;
   ColorBox->Color = AppMainForm->Color;
   GetAppData(ColorDialog1->CustomColors,"CustomColors");
   StatsMinutes->Text = GetAppIni(StatsMinUpdates,"0");
   // editor
   EdWrapWinBtn->Checked = GetAppIni(WordWrap,"").ToIntDef(1);
   EdWrapNotBtn->Checked = !EdWrapWinBtn->Checked;
   EdWrapShowBox->Checked = GetAppIni(WordWrapShowBox,"").ToIntDef(0);
   // sending mail
   bool checked = GetAppIni(SendWrapChars,"").ToIntDef(0);
   SendWrapCharEdit->Color = checked ? clWindow:clBtnFace;
   SendWrapCharBtn->Checked = checked;
   if (!SendWrapCharBtn->Checked) SendWrapCharEdit->Enabled = false;
   SendWrapCharEdit->Text = GetAppIni(SendWrapCharsCount,"65");
   SendWrapWinBtn->Checked = GetAppIni(SendWrapWin,"").ToIntDef(1);
   SendWrapNotBtn->Checked = GetAppIni(SendWrapNot,"").ToIntDef(0);
   // init
   PageControl1->ActivePage = TabSheet3;
}
*/
//---------------------------------------------------------------------------
void __fastcall TPreferForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      Hide();
      // general
      AnsiString qm=QuoteMarkEdit->Text;
      if (qm[1]=='\"') qm = qm.SubString(2,16);
      if (qm[qm.Length()]=='\"') qm.SetLength(qm.Length()-1);
      ini->Values[QuoteMarks] = qm;
      ini->Values[StatsMinUpdates] = StatsMinutes->Text;
      ini->Values[WorkSpaceColor] = AnsiString(ColorBox->Color);
      //if (AppMainForm->Color != ColorBox->Color)
          AppMainForm->Color  = ColorBox->Color;
      TStrings *colors = ColorDialog1->CustomColors;
      int p; while ((p=colors->IndexOf("FFFFFFFF"))>=0) colors->Delete(p);
      PutAppData("CustomColors",ColorDialog1->CustomColors);
      // editor
      ini->Values[WordWrap] = EdWrapWinBtn->Checked?"1":"0";
      ini->Values[WordWrapShowBox] = EdWrapShowBox->Checked?"1":"0";
      // sending mail
      ini->Values[SendWrapChars] = SendWrapCharBtn->Checked?"1":"0";
      int count = SendWrapCharEdit->Text.ToIntDef(0);
      ini->Values[SendWrapCharsCount] = AnsiString(count<16?16:count);
      ini->Values[SendWrapWin] = SendWrapWinBtn->Checked?"1":"0";
      ini->Values[SendWrapNot] = SendWrapNotBtn->Checked?"1":"0";
      ini->Values[DontWrapQuoted] = DontWrapQuotes->Checked?"1":"0";
      PutAppData(AppIniValues,ini);
   }
}
/*
void __fastcall TPreferForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      // general
      AnsiString qm=QuoteMarkEdit->Text;
      if (qm[1]=='\"') qm = qm.SubString(2,16);
      if (qm[qm.Length()]=='\"') qm.SetLength(qm.Length()-1);
      PutAppIni(QuoteMarks,qm);
      PutAppIni(StatsMinUpdates,StatsMinutes->Text);
      PutAppIni(WorkSpaceColor,AnsiString(ColorBox->Color));
      if (AppMainForm->Color != ColorBox->Color)
          AppMainForm->Color  = ColorBox->Color;
      PutAppData("CustomColors",ColorDialog1->CustomColors);
      // editor
      PutAppIni(WordWrap,EdWrapWinBtn->Checked?"1":"0");
      PutAppIni(WordWrapShowBox,EdWrapShowBox->Checked?"1":"0");
      // sending mail
      PutAppIni(SendWrapChars,SendWrapCharBtn->Checked?"1":"0");
      int count = SendWrapCharEdit->Text.ToIntDef(0);
      PutAppIni(SendWrapCharsCount,count<16?16:count);
      PutAppIni(SendWrapWin,SendWrapWinBtn->Checked?"1":"0");
      PutAppIni(SendWrapNot,SendWrapNotBtn->Checked?"1":"0");
      // init
   }
}
*/
//---------------------------------------------------------------------------
void __fastcall TPreferForm::SendWrapBtnClick(TObject *Sender)
{
   bool enabled = SendWrapCharBtn->Checked;
   SendWrapCharEdit->Color = enabled ? clWindow:clBtnFace;
   SendWrapCharEdit->Enabled = enabled;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::SendWrapCharEditExit(TObject *Sender)
{
  if (SendWrapCharEdit->Text.ToIntDef(0)<16)
     SendWrapCharEdit->Text = "16";
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::StatsMinutesExit(TObject *Sender)
{
   if (StatsMinutes->Text.ToIntDef(-1)<0)
      StatsMinutes->Text = "0";
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ColorBtnClick(TObject *Sender)
{
   ColorDialog1->Color = AppMainForm->Color;
   if (ColorDialog1->Execute() && AppMainForm->Color!=ColorDialog1->Color)
   {
       ColorBox->Color = ColorDialog1->Color;
       ApplyColorBtn->Enabled = true;
   }
   else
       ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TPreferForm::ApplyColorBtnClick(TObject *Sender)
{
   AppMainForm->Color = ColorBox->Color;
   ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
   ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
